/* (c) https://github.com/MontiCore/monticore */
#ifndef TEST_PACMANSAMPLEGAME_MAIN_GHOST3WORLDMANAGER_PACMANWORLDHANDLER_MOVEMENTHANDLER
#define TEST_PACMANSAMPLEGAME_MAIN_GHOST3WORLDMANAGER_PACMANWORLDHANDLER_MOVEMENTHANDLER
#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif
#include <cstdlib>
#include "armadillo.h"
#include "test_pacmanSampleGame_main_ghost3WorldManager_pacmanWorldHandler_movementHandler_pacmanMovementPositionCalculator.h"
#include "test_pacmanSampleGame_main_ghost3WorldManager_pacmanWorldHandler_movementHandler_pacmanMovementCollisionChecker.h"
using namespace arma;
class test_pacmanSampleGame_main_ghost3WorldManager_pacmanWorldHandler_movementHandler{
const int tilesMaxX = 17;
const int tilesMaxY = 17;
public:
bool moveUp;
bool moveDown;
bool moveLeft;
bool moveRight;
bool moveUpLastDirection;
bool moveDownLastDirection;
bool moveLeftLastDirection;
bool moveRightLastDirection;
int pacmanPositionX;
int pacmanPositionY;
imat world;
int pacmanNextPositionX;
int pacmanNextPositionY;
int pacmanNextPositionXLastDirection;
int pacmanNextPositionYLastDirection;
bool canMove;
bool canMoveLastDirection;
test_pacmanSampleGame_main_ghost3WorldManager_pacmanWorldHandler_movementHandler_pacmanMovementPositionCalculator pacmanMovementPositionCalculator;
test_pacmanSampleGame_main_ghost3WorldManager_pacmanWorldHandler_movementHandler_pacmanMovementCollisionChecker pacmanMovementCollisionChecker;
void init()
{
world=imat(tilesMaxX,tilesMaxY);
pacmanMovementPositionCalculator.init();
pacmanMovementCollisionChecker.init();
}
void execute()
{
pacmanMovementPositionCalculator.moveUp = moveUp;
pacmanMovementPositionCalculator.moveDown = moveDown;
pacmanMovementPositionCalculator.moveLeft = moveLeft;
pacmanMovementPositionCalculator.moveRight = moveRight;
pacmanMovementPositionCalculator.moveUpLastDirection = moveUpLastDirection;
pacmanMovementPositionCalculator.moveDownLastDirection = moveDownLastDirection;
pacmanMovementPositionCalculator.moveLeftLastDirection = moveLeftLastDirection;
pacmanMovementPositionCalculator.moveRightLastDirection = moveRightLastDirection;
pacmanMovementPositionCalculator.pacmanPositionX = pacmanPositionX;
pacmanMovementPositionCalculator.pacmanPositionY = pacmanPositionY;
pacmanMovementPositionCalculator.execute();
pacmanMovementCollisionChecker.moveUp = moveUp;
pacmanMovementCollisionChecker.moveDown = moveDown;
pacmanMovementCollisionChecker.moveLeft = moveLeft;
pacmanMovementCollisionChecker.moveRight = moveRight;
pacmanMovementCollisionChecker.moveUpLastDirection = moveUpLastDirection;
pacmanMovementCollisionChecker.moveDownLastDirection = moveDownLastDirection;
pacmanMovementCollisionChecker.moveLeftLastDirection = moveLeftLastDirection;
pacmanMovementCollisionChecker.moveRightLastDirection = moveRightLastDirection;
pacmanMovementCollisionChecker.world = world;
pacmanMovementCollisionChecker.pacmanPositionX = pacmanPositionX;
pacmanMovementCollisionChecker.pacmanPositionY = pacmanPositionY;
pacmanMovementCollisionChecker.pacmanPossibleNextPositionX = pacmanMovementPositionCalculator.pacmanNextPositionX;
pacmanMovementCollisionChecker.pacmanPossibleNextPositionY = pacmanMovementPositionCalculator.pacmanNextPositionY;
pacmanMovementCollisionChecker.pacmanPossibleNextPositionXLastDirection = pacmanMovementPositionCalculator.pacmanNextPositionXLastDirection;
pacmanMovementCollisionChecker.pacmanPossibleNextPositionYLastDirection = pacmanMovementPositionCalculator.pacmanNextPositionYLastDirection;
pacmanMovementCollisionChecker.execute();
pacmanNextPositionX = pacmanMovementCollisionChecker.pacmanChosenNextPositionX;
pacmanNextPositionY = pacmanMovementCollisionChecker.pacmanChosenNextPositionY;
canMove = pacmanMovementCollisionChecker.canMove;
canMoveLastDirection = pacmanMovementCollisionChecker.canMoveLastDirection;
}

};
#endif
